=== debian/changelog ===
librcsb-core-wrapper (1.005-8build2) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:20:40 +0100

librcsb-core-wrapper (1.005-8build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 20:46:12 +0000

librcsb-core-wrapper (1.005-8) unstable; urgency=medium

  * Source upload to enable testing migration

 -- Andreas Tille <tille@debian.org>  Sat, 21 Dec 2019 19:36:10 +0100

librcsb-core-wrapper (1.005-7) unstable; urgency=medium

  * Switch wrapper from Python2 to Python3
    Closes: #936910
  * debhelper-compat 10 (fails to build with 12 - so leave this for the
    moment)
  * Standards-Version: 4.4.1
  * Trim trailing whitespace.
  * Use secure URI in Homepage field.

 -- Andreas Tille <tille@debian.org>  Wed, 18 Dec 2019 16:39:25 +0100

librcsb-core-wrapper (1.005-6) unstable; urgency=medium

  * Team uploade

  [ Andreas Tille ]
  * Drop unneeded get-orig-source target
  * Fix build error with gcc-8
    Closes: #897795
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * Testsuite: autopkgtest-pkg-python
  * No Priority: extra
  * Drop ancient field X-Python-Version

  [ Michael R. Crusoe ]
  * Adapt patches for latest boost version
  * debian/watch: use secure HTTPS URL
  * Standards-Version: 4.3.0, no changes needed
  * Remove trailing whitespace in debian/copyright
  * Remove trailing whitespace in debian/rules

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 18 Jan 2019 14:14:40 -0800

librcsb-core-wrapper (1.005-5) unstable; urgency=medium

  * Enable build against libxerces-c3.2
  * Moved packaging from SVN to Git
  * Standards-Version: 4.1.1
  * debhelper 10
  * Remove -dbg packages since debug packages are autogenerated
  * DEP5
  * hardening=+all
  * remove useless autogenerated doxygen files

 -- Andreas Tille <tille@debian.org>  Tue, 07 Nov 2017 17:13:00 +0100

librcsb-core-wrapper (1.005-4) unstable; urgency=medium

  * cme fix dpkg-control
  * Fix GCC version detection (thanks for the patch to Matthias Klose
    <doko@debian.org>)
    Closes: #777971

 -- Andreas Tille <tille@debian.org>  Fri, 10 Jul 2015 18:39:50 +0200

librcsb-core-wrapper (1.005-3) unstable; urgency=medium

  * Patch for Henry Spencer regular expressions (regex) library contains
    a heap overflow vulnerability
    Closes: #778397

 -- Andreas Tille <tille@debian.org>  Sat, 14 Feb 2015 17:56:49 +0100

librcsb-core-wrapper (1.005-2) unstable; urgency=medium

  * Added libtool-bin as a build-dep (Closes: #761768).

 -- Laszlo Kajan <lkajan@debian.org>  Thu, 18 Sep 2014 21:15:13 +0200

librcsb-core-wrapper (1.005-1) unstable; urgency=medium

  * New upstream version
  * cme fix dpkg-control
  * debhelper 9
  * simplified d/rules

 -- Andreas Tille <tille@debian.org>  Tue, 29 Jul 2014 17:51:57 +0200
