=== debian/control ===
Source: librcsb-core-wrapper
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Laszlo Kajan <lkajan@debian.org>,
           Andreas Tille <tille@debian.org>
Section: libs
Testsuite: autopkgtest-pkg-python
Priority: optional
Build-Depends: debhelper-compat (= 10),
               doxygen,
               graphviz,
               dh-python,
               libboost-python-dev,
               libxerces-c-dev,
               python3-all-dev,
               libtool,
               libtool-bin,
               bison,
               flex
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/med-team/librcsb-core-wrapper
Vcs-Git: https://salsa.debian.org/med-team/librcsb-core-wrapper.git
Homepage: https://sw-tools.rcsb.org/apps/CORE-WRAPPER/index.html

Package: librcsb-core-wrapper0
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library providing OO API to information in mmCIF format
 The RCSB Core Wrapper library was developed to provide an object-oriented
 application interface to information in mmCIF format. It includes several
 classes for accessing data dictionaries and mmCIF format data files.
 .
 This package contains the shared library.

Package: librcsb-core-wrapper0-dev
Architecture: any
Section: libdevel
Depends: librcsb-core-wrapper0 (= ${binary:Version}),
         ${misc:Depends}
Suggests: librcsb-core-wrapper-doc
Provides: librcsb-core-wrapper-dev
Description: development files for librcsb-core-wrapper0
 The RCSB Core Wrapper library was developed to provide an object-oriented
 application interface to information in mmCIF format. It includes several
 classes for accessing data dictionaries and mmCIF format data files.
 .
 This package contains files necessary for developing applications with
 the library.

Package: librcsb-core-wrapper-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: documentation for librcsb-core-wrapper0
 The RCSB Core Wrapper library was developed to provide an object-oriented
 application interface to information in mmCIF format. It includes several
 classes for accessing data dictionaries and mmCIF format data files.
 .
 This package contains html documentation.

Package: python3-corepywrap
Architecture: any
Section: python
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends},
         librcsb-core-wrapper0 (= ${binary:Version})
Suggests: librcsb-core-wrapper-doc
Provides: ${python3:Provides}
Description: library that exports C++ mmCIF accessors to Python3
 The RCSB Core Wrapper library was developed to provide an object-oriented
 application interface to information in mmCIF format. It includes several
 classes for accessing data dictionaries and mmCIF format data files.
 .
 This library provides Python3 bindings for librcsb-core-wrapper.
