=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed

# lkajan: we borrow from libtorrent-rasterbar and pythonmagick here (thank you)
PYVERSIONS=$(shell pyversions -vr)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --with python3

override_dh_auto_build: override_dh_auto_build-nopy override_dh_auto_build-py

override_dh_auto_build-nopy:
	dh_auto_build
	# When using debhelper 11 something is very different in the installation.
	# The next line tries to hack around this - but this is not the solution - thus reverting debhelper compat level
	# cp -a common/include/* pdbml-parser/include/* cif-file/include/* tables/include/* include
	$(MAKE) doc

override_dh_auto_build-py: override_dh_auto_build-nopy
	dh_auto_build --sourcedirectory=wrapper/python --buildsystem=pybuild

override_dh_auto_install: override_dh_auto_install-nopy override_dh_auto_install-py

override_dh_auto_install-nopy:
	# lkajan: there is no real install mechanism in the upstream sources

override_dh_auto_install-py:
	dh_auto_install --sourcedirectory=wrapper/python --buildsystem=pybuild

override_dh_installdocs:
	dh_installdocs
	find debian -name "*.md5" -delete

override_dh_makeshlibs:
	dh_makeshlibs -V

override_dh_auto_clean:
	dh_auto_clean
	rm -rf wrapper/python/build
