=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

https://sw-tools.rcsb.org/apps/CORE-WRAPPER/source/source.html core-wrapper-v([\d.]+)-prod-src\.tar\..z
